update_sendmail_mc() {
  cp-update -c dnl $PKG $sendmail_mc <<-END
	define(\`MILTER', 1)dnl
	INPUT_MAIL_FILTER(\`amavis-milter', \`S=local:$AHOME/amavisd-new-milter.sock, F=T, T=S:10m;R:10m;E:10m')dnl
	dnl Reducing number of messages in syslog for milter
	define(\`confMILTER_LOG_LEVEL', \`4')dnl
	END
	#' XXX stupid joe syntax highlighing
}

# sendmail chunk moved out from postinst in 20030616p10-10
update_sendmail() {
  if [ -f $sendmail_mc ]; then
    # creating backup files, just in case
    cp -p $sendmail_mc $sendmail_mc.$PKG
    mcbak=1
    cp -p $sendmail_cf $sendmail_cf.$PKG
    cfbak=1

    if ! egrep -q '^INPUT_MAIL_FILTER.*amavis-milter' $sendmail_mc; then
      update_sendmail_mc
      makecf=1
    elif grep -q 'Begin update by CARNet package amavisd-cn' $sendmail_mc; then
      update_sendmail_mc
      makecf=1
    elif grep -q 'local:/var/run/amavis/amavis-milter.sock' $sendmail_mc; then
      echo "CN: You seem to have a custom configuration for milter in"
      echo "    ${sendmail_mc}. I'll try to fix it but I don't promise anything."
      echo "    Things might break or behave unexpectedly."
      cp_echo -mailonly "CN: Tried to fix custom milter config in ${sendmail_mc}."
      cp_check_and_sed "/var/run/amavis/amavis-milter.sock" \
        "s,/var/run/amavis/amavis-milter.sock,$AHOME/amavisd-new-milter.sock," \
        $sendmail_mc
      makecf=1
    fi
  fi # sendmail.mc

  # submit.mc: use /etc/mail/trusted-users, and add user amavis
  # to get rid of Authentication-Warnings
  if [ -f "$submit_mc" ]; then
    cp -p $submit_mc $submit_mc.$PKG
    subak=1
    if ! grep -q use_ct_file $submit_mc; then
      cp-update -R --insert-before '^FEATURE\(`?msp' -c dnl $PKG $submit_mc <<-END
	FEATURE(\`use_ct_file')dnl
	END
      grep -q '^amavis$' $ct_file || echo amavis >> $ct_file
      echo "CN: Added FEATURE(use_ct_file) to $submit_mc."
    fi
  fi # submit.mc

  if [ "$makecf" ]; then
    make -C /etc/mail >/dev/null 2>&1
    restart_mta=1
  else
    [ "$mcbak" ] && rm -f $sendmail_mc.$PKG
    [ "$cfbak" ] && rm -f $sendmail_cf.$PKG
    [ "$subak" ] && rm -f $submit_mc.$PKG
  fi
}

conf_sendmailize() {
  local tmp oldpwd
  tmp=`basename $ACONF.dpkg-tmp.$$`
  noisy_backup $ACONF
  # are we configured for milter?
  if ! egrep -q '^[[:blank:]]*\$notify_method = .*argv=/usr/sbin/sendmail -Ac.*-odd' $ACONF; then
    # first try to apply patch
    if catpatch $ACONF | patch -Rsfp0 --dry-run 2>&- ; then
      oldpwd=`pwd`
      cd `dirname $ACONF`
      cp -p $ACONF $tmp
      catpatch $tmp | patch -Rfp0
      cp_mv $tmp $ACONF
      cd $oldpwd
      cp_echo -mailonly "CN: $ACONF postfix patch removed."
    # then try to update exact options without disturbing anything else
    elif uncommented_in_paragraph '^[[:blank:]]*#.*POSTFIX' \
      '^$forward_method = '\''smtp:127.0.0.1:10025'\'';[[:blank:]]*(#|$)' \
      '^\$notify_method = \$forward_method;[[:blank:]]*(#|$)' \
      -f $ACONF &&
       commented_in_paragraph '^[[:blank:]]*#.*MILTER' \
      '$forward_method = undef;[[:blank:]]*(#|$)' \
      '$notify_method = .*argv=/usr/sbin/sendmail -Ac.*-odd' \
      -f $ACONF; then
      cp $ACONF $tmp
      comment_in_paragraph '^[[:blank:]]*#.*POSTFIX' \
        '^$forward_method = '\''smtp:127.0.0.1:10025'\'';[[:blank:]]*(#|$)' \
        '^\$notify_method = \$forward_method;[[:blank:]]*(#|$)' \
        -f $tmp
      uncomment_in_paragraph '^[[:blank:]]*#.*MILTER' \
        '$forward_method = undef;[[:blank:]]*(#|$)' \
        '$notify_method = .*argv=/usr/sbin/sendmail -Ac.*-odd' \
        -f $tmp
      cp_mv $tmp $ACONF
      cp_echo "CN: $ACONF updated for ${mta}."
    # or just overwrite
    else
      conf_from_template
      cp_echo "CN: Config generated from ${ACONFTMPL}."
    fi
    restart_daemon=1
    changed_config=1
  fi
}
